#
#   File        : debug.py
#   Author      : Alain TAUCH <alain.tauch@thalesatm.com>
#   Description : the Debug class
#
#   Copyright (C) 2003 Alain TAUCH
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

import sys
import types

class   Debug:
    def __init__(self, verbose_level):
        self.level = verbose_level
        
    def info2(self, message, debug_level):
        if self.level >= debug_level:
            print message

    def info3(self, message, args, debug_level):
        if self.level >= debug_level:
            print message % args

    def info4(self, args, debug_level):
        if self.level >= debug_level:
            txt = "\n" + args[0] + ":"
            others = args[1:]
            cpt = 0
            for i in others:
                if cpt == 0:
                    txt += "\n\t\\_ "
                    if i:
                        txt += "%s: " % (i, )
                    cpt = 1
                else:
                    txt += `i`
                    cpt = 0
            print txt

    def info42(self, depth, args, debug_level):
        if self.level >= debug_level:
            txt = ""
            cpt = 0
            for i in args:
                if cpt == 0:
                    for dummy in range(depth):
                        txt += "\t"
                    txt += "\\_ "
                    if i:
                        txt += "%s: " % (i, )
                    cpt = 1
                else:
                    if i == args[-1]:
                        txt += "%s" % (i, )
                    else:
                        txt += "%s\n" % (i, )
                    cpt = 0
            print txt

    def get_refcounts(self):
        d = {}
        sys.modules
        for m in sys.modules.values():
            for sym in dir(m):
                o = getattr(m, sym)
                if type(o) is types.ClassType:
                    d[o] = sys.getrefcount(o)
        pairs = map(lambda x : (x[1], x[0]), d.items())
        pairs.sort()
        pairs.reverse()
        return pairs

    def print_refcounts(self, qty, debug_level):
        if self.level >= debug_level:
            print "%d best references" % (qty, )
            for n, c in self.get_refcounts()[:qty]:
                print '%10d %s [%s]' % (n, c.__name__, c)
